#include "hmg.ch"
#include "fileio.ch"

PROCEDURE Main
SET LANGUAGE TO SLOVENIAN
REQUEST HB_CODEPAGE_SLWIN
HB_CDPSELECT("SLWIN")
HMG_MESSAGES_UTF8_TO_ANSI("SLWIN")

msginfo(HMG_CharSetName()+" "+HMG_GetLanguage())
DEFINE WINDOW Win_1  AT 0,0 WIDTH 540 HEIGHT 460 MAIN 
ON KEY ESCAPE ACTION Win_1.Release

 Define Button Button_4
 Row	300
 Col	80
 Caption 'Test EDIT'
 Action sifdavk()
 End Button

END WINDOW
Win_1.Center
Win_1.Activate
RETURN

procedure sifdavk()
         // Local variable declarations.----------------------------------------
        LOCAL aFieldName   := { "ifra", "Naziv davka", "Tarifa", "Davek v %", "Mejni datum", ;
                              "Davek % pred sprem.", "Skupaj"  }
        LOCAL aVisTable    := { .t., .t., .t., .t., .t., .t., .f. }
        LOCAL aFieldEdit   := { .t., .t., .t., .t., .t., .t., .f. }
        LOCAL aOptions     := Array( 3, 2 )
        LOCAL bSave        := {|aValues, lNew| sifdavksave( aValues, lNew, cArea ) }
        LOCAL bSearch      := {|| MsgInfo( "Your own search function" ) }
        LOCAL bPrint       := {|| MsgInfo( "Your own print function" ) }
        aOptions[1,1] := "Monost 1"
        aOptions[1,2] := { || MsgInfo( "" ) }
        aOptions[2,1] := "Monost 1"
        aOptions[2,2] := { || MsgInfo( "" ) }
        aOptions[3,1] := "Opis programa"
        aOptions[3,2] := { || MsgInfo( "" ) }
        USE SIF_DAVK
        cArea="SIF_DAVK"
        SIF_DAVK->( ordListAdd( "DAVK1.NTX", "ifra davka" ) )
        SIF_DAVK->( ordSetFocus( 1 ) ) 
        EDIT EXTENDED                           ;
                WORKAREA SIF_DAVK               ;
                TITLE "Davne skupine"   	;
                FIELDNAMES aFieldName           ;
                FIELDENABLED aFieldEdit         ;
                TABLEVIEW aVisTable             ;
                OPTIONS aOptions                ;
                ON SAVE bSave                  
        CLOSE SIF_DAVK
return

function sifdavksave( aValues, lNew, cArea )
        LOCAL i := 1
        IF Empty( aValues[1] )   // First name.
                msgInfo( "ifra davka mora biti vneena !" )
                return ( .f. )
        ENDIF
        IF lNew
                sif_davk->( dbAppend() )
        ENDIF
        FOR i := 1 TO Len( aValues )
                rlock()
                sif_davk->( FieldPut( i, aValues[i] ) )
                unlock
        NEXT  
return ( .t. )


FUNCTION HMG_MESSAGES_UTF8_TO_ANSI (cCPID)
LOCAL k, i, nIndex, cUTF8Str, cANSIStr
LOCAL aPos := {128, 129, 130, 131, 132, 133, 134, 136, 137, 331, 371}
   FOR k = 1 TO HMG_LEN (aPos)
      nIndex := aPos [k]
      IF ValType (_HMG_SYSDATA [nIndex]) == "A"
         FOR i = 1 TO HMG_LEN (_HMG_SYSDATA [nIndex])
            cUTF8Str := _HMG_SYSDATA [nIndex] [i]
            cANSIStr := HB_UTF8TOSTR (cUTF8Str, cCPID)
            _HMG_SYSDATA [nIndex] [i] := cANSIStr 
         NEXT
      ELSE
         cUTF8Str := _HMG_SYSDATA [nIndex]
         cANSIStr := HB_UTF8TOSTR (cUTF8Str, cCPID)
         _HMG_SYSDATA [nIndex] := cANSIStr 
      ENDIF
   NEXT
RETURN NIL